/* CLASSES.dm
This code contains everything needed to create classes for your
CAGE program.  Create a class datum for every class you want.
*/

/class/demo
	name = "Demo class"
	desc = "This is just a demo class.  You are stupid if you use it in your game."
	Initialize()
		owner.health = 10
		owner.maxHealth = 10

/class/default
	name = "Demo class #2"
	desc = "This is just a demo class.  You are stupid if you use it in your game."
	Initialize()
		owner.health = 10
		owner.maxHealth = 10

/class
	var
		name
		desc
		mob/owner

	proc/Initialize()
		// Called when a mob chooses this class.
	New(mob/trg)
		if(trg)
			owner = trg
			Initialize()
		return ..()

mob/player/var/class/class
mob/player/proc/Class()
	if(class) return class.name

var/Class/Class = new()
Class
	var/list/Table[0]
	New()
		for(var/t in typesof(/class)-/class)
			var/class/c = new t
			Table[c.name] = c
		return ..()

proc/ChooseClass(mob/New)
	var/class/c
	while(1)
		var/choice = input("Choose a class for your character:") in Class.Table
		world << choice
		c = Class.Table[choice]

		switch(alert(c.desc+"\nWill your character be this class?",c.name,"Yes","No"))
			if("Yes") break
	new c.type(New)